% as reqiured by minFunc, this ObjectFun_MatrixForm should return the following:
% cost: the cost of the objective function, in our case, obj = || G*SIGMA(WY) - X ||_F
% grad: the gradient w.r.t theta, in our case, grad = 2 * (G * SigmaWY - X_scaled) .* (G*SigmaWY) .* (ones - SigmaWY) * Y'
function [cost, grad] = ObjectFun_MatrixForm(theta,X,Y,G)
W = reshape(theta,size(X,1),size(Y,1));
% W = W';
X_scaled = X;
SigmaWY = sigmoid(W*Y);
dW = 2 * (G * SigmaWY - X_scaled) .* (G*SigmaWY) .* (ones - SigmaWY);%1 / size(Y,2) .* 
dW = dW * Y' + 2 * 0.0001 * W;
cost = sum(sum((G * SigmaWY - X_scaled).^2)) + 0.0001 * sum(sum(W.^2));
grad = dW(:);
% grad = grad(:);


