function feature_generation_CMC_batch_append(foldername, data_suffix_idx, feat_idx, model_fn, output_dir,whitenning,numlayers,blocksize)


fprintf('\n**********************************************************************************');
fprintf('\nCellular Morphometric Context Construction\n');
fprintf('Batch size:\t%d cellular objects per tisuue\n', blocksize);
fprintf('**********************************************************************************\n');

save_cmt_files = false;

% load([output_file_base '_model.mat']);


pathparts = regexp(foldername,filesep,'split');
if( ~isempty(pathparts{end} ) )
    subtypename = pathparts{end};
else
    subtypename = pathparts{end-1};
end

filenames = dir([foldername '*.txt']);

Y = 0;

fprintf('Data folder:\t\t%s\n',foldername);
fprintf('Num of tissue files:\t%d\n', length(filenames));

status = mkdir(output_dir);
result_folder = [output_dir filesep subtypename];
status = status & mkdir(result_folder);

if status == 0
    fprintf('creating folder failed\n')
    return
else
    fprintf('Creating folder:\t%s\tsuccessfully\n',result_folder);
end

for i = 1:length(filenames)
    
    
    output_file_base_new = [result_folder filesep filenames(i).name];
    
    feat_fn_txt = [output_file_base_new '_cmc.txt'];
    if( exist(feat_fn_txt,'file') ) % skip duplicate generation
        fprintf('Skipping:\t%s\n', feat_fn_txt);
        continue;
    end
    
    fprintf('Constructing:\t%s\n', feat_fn_txt);
    
    % create an empty file so other threads will not work on the same file
    fclose(fopen(feat_fn_txt, 'w')); 

    %Read tissue data
    fn = [foldername filesep filenames(i).name];
    data = load(fn);
    
    max_pooling = [];
    nrows = size(data,1);
    for j = 1:blocksize:nrows
	  start_idx = j;
          end_idx = j + blocksize -1;
          if(end_idx > nrows)
               end_idx = nrows;
          end
	  [feat] = feature_generation_CMC_batch_append_api(data(start_idx:end_idx,:), data_suffix_idx, feat_idx, model_fn, output_file_base_new,whitenning,numlayers,save_cmt_files);
      max_pooling = [max_pooling;max(abs(feat),[],1)];
    end
    max_pooling = max(abs(max_pooling),[],1);
    max_pooling = (max_pooling ./ sum(max_pooling)) * 100;
    cmc_fn_txt = [output_file_base_new '_cmc.txt'];
    dlmwrite(cmc_fn_txt, max_pooling,'delimiter','\t');
    Y = Y + 1;
end

return;
