function feature_learning_CMT_V5(Y, RegressionTarget, model_fn,numlayers,nbasis_vec,lambda_vec,nepoch_vec,optmethod,whitenning,initialization)
%Function to learn the CMT.

fprintf('\n**********************************************************************************');
fprintf('\nUnsupervised Cellular Morphometric Type Learning\n');
for i = 1:numlayers
    fprintf('Layer:\t%d\tDictionary Size:\t%d\tSparsity:\t%d\tNumber of iterations:\t%d\n',i,nbasis_vec(i),lambda_vec(i),nepoch_vec(i));
end
fprintf('**********************************************************************************\n');

if numlayers ~= length(nbasis_vec)
    disp(['error! number of layers does not equal to the length of nbasis_vec'])
    return
end

if whitenning == 1
    [Y, mean_patch, V] = preprocess(Y,2,1e-4);
else
    mean_patch = 0;
    V = 0;
end

W_layer = cell(numlayers,1);
D_layer = cell(numlayers,1);
G_layer = cell(numlayers,1);
X_layer = cell(numlayers,1);
A_layer = cell(numlayers,1);
Input_layer = cell(numlayers,1);
Input_layer{1,1} = Y;

scmethod = 0;
% optmethod = 0;
% initialization = 0;
tauw = 0.01;
beta = 0;
for layer_idx = 1:numlayers
    disp(['Learning layer ' num2str(layer_idx)]);
    nbasis = nbasis_vec(layer_idx);
    lambda = lambda_vec(layer_idx);
    nepoch = nepoch_vec(layer_idx);
    Input = Input_layer{layer_idx,1}; %<-------- check last output X_last layer

    [W_layer{layer_idx,1} D_layer{layer_idx,1} G_layer{layer_idx,1} X_layer{layer_idx,1} A_layer{layer_idx,1}] = LayerTrain_CMT_V5(Input,RegressionTarget,nbasis,lambda,nepoch,scmethod,optmethod,tauw,initialization,beta); %<-------- check layer index
    Input_layer{layer_idx+1,1} = X_layer{layer_idx,1}; %<-------- check layer index 
end
save(model_fn,'W_layer','D_layer','G_layer','X_layer','A_layer','mean_patch','V');
return;

