function [Y_tr L_tr Y_ts L_ts tr_idx ts_idx]= feature_learning_prepare_db_CMT(data, npatches, feat_idx, label_idx, output_file_base)
%Function to prepare the input cellular objects


Y_tr = [];
L_tr = [];

Y_ts = [];
L_ts = [];

tr_idx = [];
ts_idx = [];

features = data(:,feat_idx)';

if( label_idx ~= -1)
    targets = data(:,label_idx)';
else
    targets = zeros(1,size(data,1));
end

num_samples = size(features,2);

if( num_samples < npatches )
    Y_tr = features;
    L_tr = targets; 
    tr_idx = [1:num_samples];
else
    randidx = randperm(num_samples);
    tr_idx = randidx(1:npatches);
    ts_idx = randidx(npatches+1:end);
    Y_tr = features(:,tr_idx);
    L_tr = targets(:,tr_idx);
    Y_ts = features(:,ts_idx);
    L_ts = targets(:,ts_idx);    
end

% only save the data if specified
if exist('output_file_base','var')
    output_db_fn = [output_file_base '_db.mat'];
    save(output_db_fn, 'data','feat_idx','label_idx','tr_idx','ts_idx');
end

return
