function [Y_tr L_tr]= feature_learning_prepare_db_CMT_batch(foldernames, npatches, feat_idx, label_idx)
%Function to prepare the input cellular objects


fprintf('\n**********************************************************************************');
fprintf('\nTraining sample preparation\n');
fprintf(['Sampling rate: ' num2str(npatches) ' cellular objects per tissue\n']);
fprintf('**********************************************************************************\n');

Y_tr = [];
L_tr = [];

for jj = 1:length(foldernames)
    
    foldername = foldernames{jj};
    filenames = dir([foldername '/*.txt']);

    Y = [];
    L = [];
    
    disp(['Sampling dir: ' foldername]);
    for i = 1:length(filenames)
        disp(['Sampling from: [' num2str(i) '/' num2str(length(filenames)), '] ' filenames(i).name]);
        fn = [foldername filesep filenames(i).name];
        data = load(fn);
        [Y_ind L_ind Y_ts_tmp L_ts_tmp tr_idx_tmp ts_idx_tmp]= feature_learning_prepare_db_CMT(data, npatches, feat_idx, label_idx);
        Y = [Y Y_ind];
        L = [L L_ind];
    end
    
    Y_tr = [Y_tr Y];
    L_tr = [L_tr L];
end