clear all; close all; clc

addpath .\lib\spams-matlab
addpath .\lib\spams-matlab\build
addpath .\lib\minFunc
addpath .\api

%% exp configuration
datasetroot = '.\dataset\Study\';
outputroot = '.\dataset\CMC\';
pretrained_model_fn = ['.\dataset\Model\' filesep 'TCGA-LGG_CMT_ite100_nb256_s30_np1000_nlayers_1_20200109093810_model.mat'];
pretrained_expid = '_20200109093810';
use_pretrained_model = true; % whether to deploy above prebuilt model

datasetname = 'LGG_Dataset_StudyExample';
foldernames{1} = [datasetroot filesep datasetname filesep 'LGG' filesep];
data_suffix_idx = [1:4];
feat_idx = [5:19];
label_idx = [-1];
npatches = 1000;
numlayers = 1;
nbasis_vec = [256];
lambda_vec = [30];
nepoch_vec = [1];
optmethod = 1;
whitenning = 0;
initialization = 1;



%% CMT learning
if use_pretrained_model
    model_fn =  pretrained_model_fn;
    exp_id = pretrained_expid;
    fprintf('\n**********************************************************************************');
    fprintf('\nDeploying pretrained model:\t%s\n',model_fn);
    fprintf('Experimental ID:%s\n',exp_id);
    fprintf('**********************************************************************************\n');
else
    exp_id = datestr(now,'_yyyymmddHHMMSS'); % experiment id
    model_fn = [outputroot, filesep, datasetname, '_CMT_ite', num2str(nepoch_vec), '_nb', num2str(nbasis_vec), ...
    '_s', num2str(lambda_vec), '_np', num2str(npatches),'_nlayers_' num2str(numlayers) exp_id '.mat'];
    
    fprintf('\n**********************************************************************************');
    fprintf('\nTrain new model:\t%s\n',model_fn);
    fprintf('Experimental ID:%s\n',exp_id);
    fprintf('**********************************************************************************\n');
    
    [Y_tr, L_tr]= feature_learning_prepare_db_CMT_batch(foldernames, npatches, feat_idx, label_idx);
    feature_learning_CMT_V5(Y_tr, L_tr,model_fn,numlayers,nbasis_vec,lambda_vec,nepoch_vec,optmethod,whitenning,initialization); 
end


%% CMC construction
output_dir = [outputroot, filesep, datasetname, exp_id];
for( ii = 1:length(foldernames))
    batchsize = 100000;
    feature_generation_CMC_batch_append(foldernames{ii}, data_suffix_idx, feat_idx, model_fn, output_dir,whitenning,numlayers,batchsize);
end
